
/**************************/
/* 10. Ʈǰ   */
/**************************/
---------------------
--  p509
---------------------

SET IMPLICIT_TRANSACTIONS ON

/* -------------------------------
       <ǽ1> p510 ~ p513
---------------------------------*/

USE tempDB;
CREATE TABLE bankBook 
	(name NVARCHAR(10), 
	 money INT ,
	 CONSTRAINT CK_money
	 CHECK  (money >= 0)
 )
GO
INSERT INTO bankBook VALUES ('糲', 1000);
INSERT INTO bankBook VALUES ('', 0);

UPDATE bankBook SET money = money - 500 WHERE NAME = '糲';
UPDATE bankBook SET money = money + 500 WHERE NAME = '';
SELECT * FROM bankBook

BEGIN TRAN
	UPDATE bankBook SET money = money - 500 WHERE NAME = '糲';
COMMIT TRAN

BEGIN TRAN
	UPDATE bankBook SET money = money + 500 WHERE NAME = '';
COMMIT TRAN

UPDATE bankBook SET money = money - 600 WHERE NAME = '糲';
UPDATE bankBook SET money = money + 600 WHERE NAME = '';
SELECT * FROM bankBook

BEGIN TRAN -- 1Ʈ
	UPDATE bankBook SET money = money - 600 WHERE NAME = '糲';
    --  ߻Ǿ  ȵ. (ѹ Ͼ  )
COMMIT TRAN

BEGIN TRAN -- 2Ʈ
	UPDATE bankBook SET money = money + 600 WHERE NAME = '';
	-- μ
COMMIT TRAN

UPDATE bankBook SET money = money - 600 WHERE NAME = '';

BEGIN TRAN 
	UPDATE bankBook SET money = money - 600 WHERE NAME = '糲';
	UPDATE bankBook SET money = money + 600 WHERE NAME = '';
COMMIT TRAN
SELECT * FROM bankBook

UPDATE bankBook SET money = money - 600 WHERE NAME = '';

BEGIN TRY
	BEGIN TRAN 
		UPDATE bankBook SET money = money - 600 WHERE NAME = '糲';
		UPDATE bankBook SET money = money + 600 WHERE NAME = '';
	COMMIT TRAN
END TRY
BEGIN CATCH
	ROLLBACK TRAN
END CATCH;
SELECT * FROM bankBook

/* -------------------------------
       <ǽ2> p513 ~ p519
̹ ǽ â  ʿϹǷ, 
縦 ؼ Ʒ SQL  â ؾ .
---------------------------------*/

USE tempDB

CREATE TABLE testTbl (id int IDENTITY); -- INSERT ׽Ʈ
CREATE TABLE tranTbl (save_id  int , tranNum int); -- Ʈ  

CREATE TRIGGER trgTranCount
	ON testTbl
	FOR INSERT
AS
	DECLARE @id int
	SELECT @id = id FROM inserted
	INSERT INTO tranTbl VALUES (@id, @@trancount)

INSERT INTO testTbl DEFAULT VALUES;

SELECT * FROM testTbl;
SELECT * FROM tranTbl;

BEGIN TRAN 
	PRINT 'BEGIN Ʈǰ==> ' + CAST ( @@trancount AS CHAR(3))
COMMIT TRAN 
PRINT 'COMMIT ĿƮǰ==> ' + CAST ( @@trancount AS CHAR(3))	

BEGIN TRAN 
	BEGIN TRAN 
		PRINT 'BEGIN 2Ʈǰ==> ' + CAST ( @@trancount AS CHAR(3))
	COMMIT TRAN 
	PRINT 'BEGIN 1Ʈǰ==> ' + CAST ( @@trancount AS CHAR(3))
COMMIT TRAN 
PRINT 'COMMIT ĿƮǰ==> ' + CAST ( @@trancount AS CHAR(3))	

CREATE TABLE #tranTest (id int);
INSERT INTO #tranTest VALUES(0);

BEGIN TRAN --- 1Ʈ
	UPDATE #tranTest SET id = 111;
	BEGIN TRAN -- 2Ʈ
		UPDATE #tranTest SET id = 222;
		SELECT * FROM #tranTest
	ROLLBACK TRAN  -- ù°ѹ
	SELECT * FROM #tranTest
ROLLBACK TRAN -- ι°ѹ
SELECT * FROM #tranTest

BEGIN TRAN --- 1Ʈ
	UPDATE #tranTest SET id = 111;
	SAVE TRAN [tranPoint1]
	BEGIN TRAN -- 2Ʈ
		UPDATE #tranTest SET id = 222;
		SELECT * FROM #tranTest
	ROLLBACK TRAN [tranPoint1] -- ù°ѹ
	SELECT * FROM #tranTest
ROLLBACK TRAN -- ι°ѹ
SELECT * FROM #tranTest

SET IMPLICIT_TRANSACTIONS ON

USE master;
CREATE DATABASE tranDB;
GO

USE tranDB;
CREATE TABLE tranTbl (id int);
GO

INSERT INTO tranTbl VALUES(1);
INSERT INTO tranTbl VALUES(2);

SELECT * FROM tranTbl;

USE tranDB;
GO
SELECT * FROM tranTbl;

ROLLBACK TRAN

CREATE TABLE tranTbl (id int);
GO

INSERT INTO tranTbl VALUES(1);
SELECT @@trancount;

BEGIN TRAN
	INSERT INTO tranTbl VALUES(2);
	SELECT @@trancount;
COMMIT TRAN

SELECT @@trancount;

BEGIN TRAN
	INSERT INTO tranTbl VALUES(3);
	SELECT @@trancount;
ROLLBACK TRAN

SELECT @@trancount;	
SELECT * FROM tranTbl;

SET IMPLICIT_TRANSACTIONS OFF


/* -------------------------------
       <ǽ3> p521 ~ p523
̹ ǽ â  ʿϹǷ, 
縦 ؼ Ʒ SQL  â ؾ .
---------------------------------*/

DBCC USEROPTIONS

USE tranDB;
CREATE TABLE isoTbl 
	(name NVARCHAR(10), 
	 money INT  )
GO
INSERT INTO isoTbl VALUES ('糲', 1000);
INSERT INTO isoTbl VALUES ('', 0);

BEGIN TRAN
	UPDATE isoTbl SET money = money - 500 WHERE name = '糲';
	UPDATE isoTbl SET money = money + 500 WHERE name = '';

SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;

USE tranDB;
SELECT * FROM isoTbl WHERE name = ''

ROLLBACK TRAN
SELECT * FROM isoTbl


/* -------------------------------
       <ǽ4> p525 ~ p526
̹ ǽ â  ʿϹǷ, 
縦 ؼ Ʒ SQL  â ؾ .
---------------------------------*/

USE tranDB;
BEGIN TRAN
	UPDATE isoTbl SET money = money - 500 WHERE name = '糲';
	UPDATE isoTbl SET money = money + 500 WHERE name = '';

DBCC USEROPTIONS

USE tranDB;
SELECT * FROM isoTbl WHERE name = ''

ROLLBACK TRAN

BEGIN TRAN
	SELECT * FROM isoTbl;

BEGIN TRAN
	UPDATE isoTbl SET money = money - 500 WHERE name = '糲';
	UPDATE isoTbl SET money = money + 500 WHERE name = '';
COMMIT TRAN

	SELECT * FROM isoTbl;
COMMIT TRAN

SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;
GO
BEGIN TRAN
	SELECT * FROM isoTbl;

BEGIN TRAN
	UPDATE isoTbl SET money = money - 500 WHERE name = '糲';
	UPDATE isoTbl SET money = money + 500 WHERE name = '';
COMMIT TRAN

	SELECT * FROM isoTbl;
COMMIT TRAN


/* -------------------------------
       <ǽ5> p527 ~ p531
̹ ǽ â  ʿϹǷ, 
縦 ؼ Ʒ SQL  â ؾ .
---------------------------------*/

SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;
GO
USE tranDB;
BEGIN TRAN
	SELECT * FROM isoTbl;

USE tranDB;
INSERT INTO isoTbl VALUES ('ֿ',5000);

	SELECT * FROM isoTbl;
COMMIT TRAN

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;
GO
BEGIN TRAN
	SELECT * FROM isoTbl;

INSERT INTO isoTbl VALUES ('',10000);

	SELECT * FROM isoTbl;
COMMIT TRAN

SELECT * FROM isoTbl;

USE tranDB;
ALTER DATABASE tranDB SET ALLOW_SNAPSHOT_ISOLATION ON;
SET TRANSACTION ISOLATION LEVEL SNAPSHOT;

BEGIN TRAN
	SELECT * FROM isoTbl;

USE tranDB;
BEGIN TRAN
	INSERT INTO isoTbl VALUES ('', 100);
	INSERT INTO isoTbl VALUES ('ȫ', 200);
	INSERT INTO isoTbl VALUES ('', 300);
COMMIT TRAN

SELECT * FROM isoTbl;

COMMIT TRAN
SELECT * FROM isoTbl;


/* -------------------------------
       <ǽ6> p534 ~ p538
̹ ǽ â  ʿϹǷ, 
縦 ؼ Ʒ SQL  â ؾ .
---------------------------------*/

USE master;
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE;
GO
USE sqlDB;

SELECT * FROM userTbl;

SELECT resource_type, resource_database_id, resource_associated_entity_id, request_mode 
	FROM sys.dm_tran_locks

BEGIN TRAN
	SELECT * FROM userTbl WHERE name = '賲';

ROLLBACK TRAN
BEGIN TRAN
	SELECT * FROM userTbl WITH (REPEATABLEREAD) WHERE name = '賲';

SELECT OBJECT_NAME(2073058421);

USE sqlDB;

BEGIN TRAN
	SELECT * FROM userTbl;

UPDATE userTbl SET addr = '' WHERE name = '賲'	

INSERT INTO userTbl(userID,name,birthYear,addr) VALUES ('DTI','',2003,'')

COMMIT TRAN

BEGIN TRAN
	SELECT * FROM userTbl WITH (TABLOCK,XLOCK) WHERE name = '賲';

BEGIN TRAN
	SELECT * FROM userTbl;


/* -------------------------------
       <ǽ7> p539 ~ p541
̹ ǽ â  ʿϹǷ, 
縦 ؼ Ʒ SQL  â ؾ .
---------------------------------*/

SELECT @@lock_timeout

USE tempDB;
CREATE TABLE blockTbl (id INT);
GO
BEGIN TRAN
	INSERT INTO blockTbl VALUES(1);

USE tempDB;
SELECT * FROM blockTbl;

SET LOCK_TIMEOUT 15000

SELECT * FROM blockTbl;

ROLLBACK TRAN;

SET LOCK_TIMEOUT 15000

BEGIN TRAN
	INSERT INTO blockTbl VALUES(1);

SELECT * FROM blockTbl;

SELECT @@TRANCOUNT


/* -------------------------------
       <ǽ8> p541 ~ p544
̹ ǽ â  ʿϹǷ, 
縦 ؼ Ʒ SQL  â ؾ .
---------------------------------*/

USE tempDB;

CREATE TABLE deadTbl1 (id int);
GO
INSERT INTO deadTbl1 VALUES (1);

USE tempDB;

CREATE TABLE deadTbl2 (id CHAR(1));
GO
INSERT INTO deadTbl2 VALUES ('A');

BEGIN TRAN
	INSERT INTO deadTbl1 VALUES(2);

BEGIN TRAN
	INSERT INTO deadTbl2 VALUES('B');

SELECT resource_type, resource_database_id, resource_associated_entity_id, request_mode 
	FROM sys.dm_tran_locks

SELECT * FROM deadTbl1;

SELECT * FROM deadTbl2  ;

SELECT @@TRANCOUNT


/* -------------------------------
       <ǽ9> p546 ~ p548
̹ ǽ  ΰ ʿϹǷ, 
縦 ؼ Ʒ SQL Ѽ ؾ .
---------------------------------*/

USE tempDB;
CREATE TABLE bankBook 
	(name NVARCHAR(10), 
	 money INT ,
	 CONSTRAINT CK_money
	 CHECK  (money >= 0)
 )
GO
INSERT INTO bankBook VALUES ('', 0);

EXEC sp_addlinkedserver   
   @server='SECONDBANK', 
   @srvproduct='SQLServer', 
   @provider='SQLNCLI', 
   @datasrc='BRAIN\SECOND' -- ڿ ٸ

USE tempDB;
DROP TABLE bankBook; -- Ѵ. ߻ǵ.
CREATE TABLE bankBook 
	(name NVARCHAR(10), 
	 money INT ,
	 CONSTRAINT CK_money
	 CHECK  (money >= 0)
 )
GO
INSERT INTO bankBook VALUES ('糲', 1000);

SET XACT_ABORT ON
GO
BEGIN DISTRIBUTED TRANSACTION 
	UPDATE bankBook SET money = money - 500 WHERE NAME = '糲';
	UPDATE SECONDBANK.tempDB.dbo.bankBook SET money = money + 500 WHERE NAME = '';
COMMIT TRANSACTION

SELECT * FROM bankBook;
SELECT * FROM SECONDBANK.tempDB.dbo.bankBook;

SET XACT_ABORT ON
GO
BEGIN DISTRIBUTED TRANSACTION 
	UPDATE bankBook SET money = money - 600 WHERE NAME = '糲';
	UPDATE SECONDBANK.tempDB.dbo.bankBook SET money = money + 600 WHERE NAME = '';
COMMIT TRANSACTION

SET XACT_ABORT ON
GO
BEGIN DISTRIBUTED TRANSACTION 
	UPDATE bankBook SET money = money - 300 WHERE NAME = '糲';
	UPDATE SECONDBANK.tempDB.dbo.bankBook SET money = money + 300 WHERE NAME = '';
COMMIT TRANSACTION

SELECT * FROM bankBook;


